/*   
    
    Ec  Vers  2.9.1-2    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/


/*#include<bios.h>
 borland C!.....*/
#include "ec_data.h"
/*****************************************************************************/
/*  Main                                                                     */
/*****************************************************************************/
main()
{
	mnu_cde();

	return 0;
}
/*****************************************************************************/
/*  test  bug                                                               */
/*****************************************************************************/

void test   (void)
{
	int t;
	ts_hst_pro[0].ti_roc_cam_typ[1][1]=0;

	printf("%i",t);
	t = getchar();
}
/*****************************************************************************/
/*  test  perfo                                                              */
/*****************************************************************************/

void test2   (void)
{
	char com[4];
	char arg1[3];
	char arg2[3];

	printf(">");
	scanf("%3s",com);
	if (com[0]=='q')
		return ;
	if (com[0] =='p')
	{
	scanf("%2s",arg1);
	scanf("%2s",arg2);
	}

	printf("\ncom:%s",com);
	printf("\narg1:%s",arg1);
	printf("\narg2:%s",arg2);

}

/*****************************************************************************/
/*  Affichage                                                                */
/*****************************************************************************/

/*  Menu de commande                                                         */

void mnu_cde (void)
{
	/* */
	char tc_com[4];
	/* */
	int i_cam;

	/* argument p:play et m:move */
	char tc_dep[3];               		/* case de depart ex:A1 */
	char tc_arr[3];               		/* case d'arrive ex:B2 */
	/* initialisation programme */
	ini_pgm();

	/* valeur par default */
	c_jou[0] 		= 'h'; 			/* blanc */
	c_jou[1] 		= 'm';          /* noir  */
	ini_hst_cam(1);                 /* pro 0 = cam 1(noir) */
	ts_hst_pro[0].i_ech =0;
	ts_hst_pro[0].i_mat =0;
	ts_hst_pro[0].i_pat =1;

	i_pro_sim_niv	= 4;				/* niveau par default */
	i_pro_sim_inc	= 2;				/* niveau par default */
	i_pro_act		= 0;				/* profondeur actuelle */
	i_pro_sim_max_sup	=               	/* profondeur de sim max */
		i_pro_act + i_pro_sim_niv;  	/* pour aff_hst */
	i_pro_sim_max_inf	=               	/* profondeur de sim max */
		i_pro_sim_max_sup + i_pro_sim_inc;  /* pour aff_hst */

	printf("\nLicence GNU Copy Right Marc Dechico  This programm is bugged and use pointers");   
	printf("\nA file named GNU_Licence is provided with the source of this programm ");   
	printf("\nType h for help ");   
	
	if(c_jou[1] == 'h')
			aff_ech(1);
	else
			aff_ech(0);

	while (1)
	{
		printf(
		"\nBlanc= %c Noir= %c Niv= %i Inc= %i Pro Act: %i Joueur: %c ",
		c_jou[0],
		c_jou[1],
		i_pro_sim_niv,
		i_pro_sim_inc,
		i_pro_act,
		c_jou[ts_hst_pro[i_pro_act+1].i_cam]
		);

		printf("\n>");
		scanf("%3s",tc_com);

		switch ( tolower (tc_com[0]) )
		{
			case 'p':                   /*print */

				switch ( tolower (tc_com[1]) )
				{
						case 'h':                   /* history */
							aff_hst(i_pro_act,i_pro_sim_max_inf);
							break;

						case 'p':                   /* piece */
							scanf("%i",&i_cam);
							aff_pie(i_cam);
							break;

						case 'b':                   /* board */
							if (c_jou[0] == 'h')
								aff_ech(0);
							else
								if(c_jou[1] == 'h')
									aff_ech(1);
								else
									aff_ech(0);
							break;

						case 'm':                   /* mark */
							aff_not_2();
							break;

						default:
							mnu_hlp();
							break;

				}
				break ;

			case 'm':                  	/* move */

				scanf("%2s",tc_dep);
				scanf("%2s",tc_arr);
				jou(tc_dep,tc_arr);
				if(c_jou[1] == 'h')
					aff_ech(1);
				else
					aff_ech(0);

				break;

			case 'b':                  	/* annule coup */
				 if (i_pro_act <1)
				 {
					printf("\n Pas de coup precedent");
				 }
				 else
				 {
					ann_cou();
					if(c_jou[1] == 'h')
						aff_ech(1);
					else
						aff_ech(0);

				 }
				break;

			case 'r':                   /* reckon  */

				simul();
				break ;

			case 's':                   /* side choice  */
				scanf("%1s",&(c_jou[0]));
				scanf("%1s",&(c_jou[1]));

				if 	(
						!
						(
							(c_jou[0] == 'h' && c_jou[1] == 'm')
							||
							(c_jou[0] == 'm' && c_jou[1] == 'h')
						)
					)
				{
					printf("\nunauthorised choice: ");
					printf("\neither s h m for white= human    and black= machine ");
					printf("\nor      s m h for white= machine  and black= human ");
					c_jou[0] = 'h';
					c_jou[1] = 'm';
				}
				break ;

			case 'l':                   /* level */

				scanf("%i",&i_pro_sim_niv);
				scanf("%i",&i_pro_sim_inc);
				if(i_pro_sim_niv>8 || i_pro_sim_niv<2)
				{
					printf("\nError: Level must be  2 to 8");
					i_pro_sim_niv = 2;

				}
				else
				{
					if(i_pro_sim_inc>4 || i_pro_sim_inc<0)
					{
							i_pro_sim_inc = 0;
							printf("\nError: Increment must be 0 to 4");

					}
				}
				break ;


			case 'h':                   /* help */
	 	    		mnu_hlp();
				break;

			case 'q':                   /* quit */

				return ;

			default:
				printf("\nUnknown command");
				mnu_hlp();
				break;
		}
	fflush(stdin);
	}

}
/* affichage aide du menu cde  */
void mnu_hlp (void)
{

	printf("\nhelp                  : h");
	printf("\nprint board           : pb");
	printf("\nprint marks           : pm");
	printf("\nmove                  : m  A2 A4");
	printf("\nback                  : b ");
	printf("\nreckon(compute marks) : r");
	printf("\nlevel (deepness)      : l 4 2");
	printf("\nside (choice)         : s h m (white= human black=machine)");
	printf("\nprint pieces(debug)   : pp 0 (for the whites) or pp  1 (for the blacks)");
 
	printf("\nprint history(debug)  : ph");
	printf("\nquit                  : q");
}
/* joue    						  */
void jou (char *ptc_dep,char *ptc_arr)
{

	int i_pos_dep_x;
	int i_pos_dep_y;
	int i_pos_arr_x;
	int i_pos_arr_y;

	/* tst joue */
	/*printf("joue");*/

	/* traduction position en coordonne */
	i_pos_dep_x = tra_col(*(ptc_dep));
	if (i_pos_dep_x == 0)
	{
		printf("\ncolonne position de depart invalide");
		return;
	}
	i_pos_dep_y = tra_lig(*(ptc_dep+1));
	if (i_pos_dep_y == 0)
	{
		printf("\nligne position de depart invalide");
		return;
	}

	i_pos_arr_x = tra_col(*(ptc_arr));
	if (i_pos_arr_x == 0)
	{
		printf("\ncolonne position d'arrive invalide");
		return;
	}

	i_pos_arr_y = tra_lig(*(ptc_arr+1));
	if (i_pos_arr_y == 0)
	{
		printf("\nligne position d'arrive invalide");
		return;
	}
	/* pas de pice */
	if (ts_ech[i_pos_dep_x][i_pos_dep_y].i_cam == -1)
	{
		printf("\nPas de pice  cette position");
		return;
	}

	/* camp invalide */
	if (ts_ech[i_pos_dep_x][i_pos_dep_y].i_cam
		!=
		ts_hst_pro[i_pro_act+1].i_cam)
	{
		printf("\nCe n'est pas au tour de ce camp de jouer");
		return;
	}


	/* prise pice propre camp invalide */
	if (ts_ech[i_pos_arr_x][i_pos_arr_y].i_cam
		==
		ts_hst_pro[i_pro_act+1].i_cam)
	{
		printf("\nPrise pice propre camp imposible");
		return;
	}
	/*tst */
	/*printf("\n jou pos_dep x/y: %i %i", i_pos_dep_x,i_pos_dep_y);*/
	jou_pro_sui(i_pos_dep_x,
				i_pos_dep_y,
				i_pos_arr_x,
				i_pos_arr_y);
	
	/* appell fonction joue propre  la pice */
	(*(tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id)->pf_jou)();
}
void jou_pro_sui(int i_pos_dep_x,int i_pos_dep_y,int i_pos_arr_x,
				 int i_pos_arr_y)
{

	/* tst */	
	/*printf("\n jou pos_dep x/y: %i %i", i_pos_dep_x,i_pos_dep_y);*/

	/* initialiasation historique  pour coup suivant */

	i_pro_act++;

	/* initialisation du  pionteurs sur hst */
	pts_hst_pro 	= &ts_hst_pro[i_pro_act];
	pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];


	/* renseigne hst */
	pts_hst_pro->i_Id =ts_ech[i_pos_dep_x][i_pos_dep_y].i_Id;
	pts_hst_pro->i_pos_ori_x = i_pos_dep_x;
	pts_hst_pro->i_pos_ori_y = i_pos_dep_y;
	pts_hst_pro->i_pos_x = i_pos_arr_x;
	pts_hst_pro->i_pos_y = i_pos_arr_y;

	/* charge hst avec pos roi camp propre et adverse */
	hst_pos_roi();

	/* initialisation du  pionteurs piece actuelle  */
	pts_pie =
	tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;

	/* calcul echec par demasquage sur roi camp adverse */
	ech_cal_dir_dem  (	pts_hst_pro->i_cam_adv,
						&(pts_hst_pro->i_ech_dir_dem));
	/* calcul echec par demasquage sur roi propre camp   */
	ech_cal_dir_dem  (	pts_hst_pro->i_cam,
						&(pts_hst_pro->i_ech_dir_dem_p_c));


}

/* traduit colonne   */
int tra_col (char c_col)
{
	switch (tolower (c_col))
			{
				case 'a':
					return 2;

				case 'b':
					return 3;

				case 'c':
					return 4;

				case 'd':
					return 5;

				case 'e':
					return 6;

				case 'f':
					return 7;

				case 'g':
					return 8;

				case 'h':
					return 9;

				default:
					break;

			}
			return 0;
}

/* traduit colonne   */
int tra_lig (char c_lig)
{
	int pos_lig;
	switch (c_lig)
			{
				case '1':
					pos_lig = 2;
					break;
				case '2':
					pos_lig = 3;
					break;
				case '3':
					pos_lig = 4;
					break;
				case '4':
					pos_lig = 5;
					break;
				case '5':
					pos_lig = 6;
					break;
				case '6':
					pos_lig = 7;
					break;
				case '7':
					pos_lig = 8;
					break;
				case '8':
					pos_lig = 9;
					break;
				default:
					pos_lig = 0;
					break;
			}
   return pos_lig;
}

/* joue roi						  */
void jou_roi (void)
{
	/* mouvement de type roc */

	if  	/* si petit petit rock blanc demand */
	(
		pts_hst_pro->i_pos_ori_x	==6
		&&
		pts_hst_pro->i_pos_ori_y	==2
		&&
		pts_hst_pro->i_pos_x		==8
		&&
		pts_hst_pro->i_pos_y		==2
	)
	{

		if
		(
			ts_ech[6][2].i_cam!=BLANC
			||
			ts_hst_pro[i_pro_act+1].
			ti_roc_cam_typ[BLANC][PET_ROC]!=0
		)

		{
			printf("\nPetit rock plus possible");
			pro_pre();
			return;
		}
		else
		{

			jou_pet_roc_0();
			return;
		}
	}
	else
	{

			if  /* si petit petit rock noir demand */
			(
			pts_hst_pro->i_pos_ori_x	==6
			&&
			pts_hst_pro->i_pos_ori_y	==9
			&&
			pts_hst_pro->i_pos_x		==8
			&&
			pts_hst_pro->i_pos_y		==9
			)
			{

				if
				(
				ts_ech[6][9].i_cam!=NOIR
				||
				ts_hst_pro[i_pro_act+1].
				ti_roc_cam_typ[NOIR][PET_ROC]!=0
				)
				{
					printf("\nPetit rock plus possible");
					pro_pre();
					return;
				}
				else
				{

					jou_pet_roc_1();
					return;
				}

			}
			else
			{

					if    	/* si grd rock blanc demand */
					(
					pts_hst_pro->i_pos_ori_x	==6
					&&
					pts_hst_pro->i_pos_ori_y	==2
					&&
					pts_hst_pro->i_pos_x		==4
					&&
					pts_hst_pro->i_pos_y		==2
					)
					{
						if
						(

						ts_ech[6][2].i_cam!=BLANC
						||
						ts_hst_pro[i_pro_act+1].
						ti_roc_cam_typ[BLANC][GRA_ROC]!=0
						)
						{
							printf("\nGrand rock plus possible");
							pro_pre();
							return;
						}
						else
						{

							jou_grd_roc_0();
							return;
						}

					}
					else
					{

						if    	/* si grd rock noir demand */
						(
						pts_hst_pro->i_pos_ori_x	==6
						&&
						pts_hst_pro->i_pos_ori_y	==9
						&&
						pts_hst_pro->i_pos_x		==4
						&&
						pts_hst_pro->i_pos_y		==9
						)
						{

							if
							(
							ts_ech[6][9].i_cam!=NOIR
							||
							ts_hst_pro[i_pro_act+1].
							ti_roc_cam_typ[NOIR][GRA_ROC]!=0
							)

							{
								printf("\nGrand rock plus possible");
								pro_pre();
								return;
							}
							else
							{

								jou_grd_roc_1();
								return;
							}

						}
					}

			}
	}

	/* inclure test le delta x et y pour valider deplacement */


	/* mouvement autre que roc */

	if  	/* prise simple de pice */

	(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
		==
		pts_hst_pro->i_cam_adv)
	{

		pts_hst_pro->i_typ_mvt = MVT_PRI_SIM;
		pri_sim();

	}
	else    /* deplacement simple */
	{

		pts_hst_pro->i_typ_mvt = MVT_DEP_SIM;
		dep_sim();

	}

	if (cas_ctl_sta(pts_hst_pro->i_pos_x,
				pts_hst_pro->i_pos_y,
				pts_hst_pro->i_cam_adv))
	{
		printf("\nLe roi se retrouve echec mvt impossible");
		ann_cou();
	}
	else
	{
		/* roi ne se retrouve pas echec donc pat = N  */
		pts_hst_pro_p->i_pat = 0;
		/* verifie si cause echec camp adverse */
		/* par par demasquage*/
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
								(pts_hst_pro->i_pos_x_R_c_a,
								 pts_hst_pro->i_pos_y_R_c_a,
								 pts_hst_pro->i_cam)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}
		/* petit et grd rock plus possible */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC]
		=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC];

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC]
		=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC] ;


	}
}
void jou_grd_roc_0 	(void)
{
		/* blanc */
		if
		(
		pts_hst_pro->
		ti_roc_cam_typ[BLANC][GRA_ROC]		 /* roi ou tour deplace */
		||
		ts_ech[2][2].i_Id!=
		 ti_tou_cam_typ[BLANC][GRA_ROC]		 /* tour supprime car pas deplace*/
		||
		pts_hst_pro_p->i_ech				 /* echec prof precedente */
		||
		ts_ech[3][2].i_cam!=-1			   	 /* case intermedaire  non vide*/
		||
		ts_ech[4][2].i_cam!=-1
		||
		ts_ech[5][2].i_cam!=-1
		||
		(*pf_cas_ctl_pos[3][2])	(3,2)        /* ou sous ctl adversaire */
		||
		(*pf_cas_ctl_pos[4][2])	(4,2)
		||
		(*pf_cas_ctl_pos[5][2])	(5,2)
		)
		{
			printf("\nGrand rock impossible");
			ann_cou();

		}
		else					/* roc possible */
		{
			pts_hst_pro->i_typ_mvt = MVT_GRA_ROC;                /*grd rock */
			pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
			dep_grd_roc_0();                            /* mvt des pices */
			jou_mvt_roi_roc(5,2);
		}
}
void jou_grd_roc_1 	(void)
{
		/* noir */
		if
		(
		pts_hst_pro->
		ti_roc_cam_typ[NOIR][GRA_ROC] 	     /* roi ou tour deplace */
		||
		ts_ech[2][9].i_Id!=
		ti_tou_cam_typ[NOIR][GRA_ROC]	   	 /* tour supprime car pas deplace*/
		||
		pts_hst_pro_p->i_ech				 /* echec prof precedente */
		||
		ts_ech[3][9].i_cam!=-1			   	 /* case intermedaire non vide*/
		||
		ts_ech[4][9].i_cam!=-1
		||
		ts_ech[5][9].i_cam!=-1
		||
		(*pf_cas_ctl_pos[3][9])	(3,9)        /*  ou sous ctl adversaire */
		||
		(*pf_cas_ctl_pos[4][9])	(4,9)
		||
		(*pf_cas_ctl_pos[5][9])	(5,9)
		)
		{
			printf("\nGrand rock impossible");
			ann_cou();
		}
		else					/* roc possible */
		{
			pts_hst_pro->i_typ_mvt = MVT_GRA_ROC;                /* grand rock */
			pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
			dep_grd_roc_1();                            /* mvt des pices */
			jou_mvt_roi_roc(5,9);
		}
}

void jou_pet_roc_0 	(void)
{

		/* blanc */
		if
		(
		pts_hst_pro->
		ti_roc_cam_typ[BLANC][PET_ROC] 			 /* roi ou tour deplace */
		||
		ts_ech[9][2].i_Id!=
		ti_tou_cam_typ[BLANC][PET_ROC]	   	 /* tour supprime car pas deplace*/
		||
		pts_hst_pro_p->i_ech				 /* echec prof precedente */
		||
		ts_ech[7][2].i_cam!=-1			   	 /* case intermedaire non vide*/
		||
		ts_ech[8][2].i_cam!=-1
		||
		(*pf_cas_ctl_pos[7][2])	(7,2)        /* ou sous ctl adversaire */
		||
		(*pf_cas_ctl_pos[8][2])	(8,2)
		)
		{
			printf("\nPetit rock impossible");
			ann_cou();
		}
		else					/* roc possible */
		{
			pts_hst_pro->i_typ_mvt = MVT_PET_ROC;                /*petit rock */
			pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
			dep_pet_roc_0();                            /* mvt des pices */
			jou_mvt_roi_roc(7,2);
		}
}
void jou_pet_roc_1 	(void)
{
		/* noir */
		if
		(
		pts_hst_pro->
		ti_roc_cam_typ[NOIR][PET_ROC] 		 /* roi ou tour deplace */
		||
		ts_ech[9][9].i_Id!=
		ti_tou_cam_typ[NOIR][PET_ROC]	   	 /* tour supprime car pas deplace*/
		||
		pts_hst_pro_p->i_ech				 /* echec prof precedente */
		||
		ts_ech[7][9].i_cam!=-1			   	 /* case intermedaire non vide*/
		||
		ts_ech[8][9].i_cam!=-1
		||
		(*pf_cas_ctl_pos[7][9])	(7,9)        /* ou sous ctl adversaire */
		||
		(*pf_cas_ctl_pos[8][9])	(8,9)
		)
		{
			printf("\nPetit rock impossible");
			ann_cou();
		}
		else					/* roc possible */
		{
			pts_hst_pro->i_typ_mvt = MVT_PET_ROC;       /*petit rock */
			pts_hst_pro_p->i_pat   = 0;                 /* pas d'echec poss*/
			dep_pet_roc_1();                            /* mvt des pices */
			jou_mvt_roi_roc(7,9);

		}
}
void jou_mvt_roi_roc 		(int i_pos_x_tou,int i_pos_y_tou)
{
		/* verifie si cause echec camp adverse */
		/* par la tour */
		if
		(
			ech_par_tou
			(
			i_pos_x_tou,
			i_pos_y_tou,
			&(pts_hst_pro->i_ech_dir_pri)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}

		/* petit et grd rock plus possible */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;

		/* recopie valeur grd et petit rock pour cam adverse */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC]
		=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC];

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC]
		=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC] ;


}

/* joue cavalier tour fou reine				  */
void jou_ctfr (void)
{

	/* determine type de mouvement: prise ou deplacement */
	if(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam == -1)
	{
		/* deplacement simple */
		pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
		dep_sim();
	}
	else
	{
		/* prise simple */
		pts_hst_pro->i_typ_mvt = MVT_PRI_SIM;
		pri_sim();
	}

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par piece principale pro precedente ? */
		/* 	ou	par piece secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			printf("\n Le roi se retrouve echec mvt impossible");
			ann_cou();
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{
		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			printf("\n Le roi se retrouve echec mvt impossible");
			ann_cou();
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	/* verifie si cause echec camp adverse */

	/* par mvt piece principale ou par demasquage*/
	if
	(
		(*pts_pie->pf_ech_par)
				(pts_hst_pro->i_pos_x,
				 pts_hst_pro->i_pos_y,
				 &(pts_hst_pro->i_ech_dir_pri))
		||
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
								(pts_hst_pro->i_pos_x_R_c_a,
								 pts_hst_pro->i_pos_y_R_c_a,
								 pts_hst_pro->i_cam)
		)
	)
	{
	   /* debug */
	   printf("\nechec detect:dir_pri=%i ",pts_hst_pro->i_ech_dir_pri);
	   pts_hst_pro->i_ech=1;
	   pts_hst_pro->i_mat=1;
	   pts_hst_pro->i_pat=0;

	}
	else
	{
	   /* debug */
	   printf("\npas d'echec detect");
	   pts_hst_pro->i_ech=0;
	   pts_hst_pro->i_mat=0;
	   pts_hst_pro->i_pat=1;
	}
	/* Mise  jour roc si tour deplace  */
	if 	(	pts_pie->c_typ_pie=='T')
	{
		/* si tour grand roc */
		if
		(
		pts_hst_pro->i_Id
		==
		ti_tou_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
		)
		{
			/* grd rock propre camp plus possible */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]= 1;

			/* recopie valeur pet rock pour propre camp */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]
			=
			pts_hst_pro->
			ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC];
		}
		/* si tour petit roc */
		if
		(
		pts_hst_pro->i_Id
		==
		ti_tou_cam_typ[pts_hst_pro->i_cam][PET_ROC]
		)
		{
			/* pet rock propre camp plus possible */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]= 1;

			/* recopie valeur grd rock pour propre camp */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
			=
			pts_hst_pro->
			ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC];
		}

	}
	else
	{
			/* recopie valeur pet rock pour propre camp */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]
			=
			pts_hst_pro->
			ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC];

			/* recopie valeur grd rock pour propre camp */
			(pts_hst_pro+1)->
			ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]
			=
			pts_hst_pro->
			ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC];
	}
	/* recopie valeur grd et petit rock pour cam adverse */
	(pts_hst_pro+1)->
	ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC]
	=
	pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC];

	(pts_hst_pro+1)->
	ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC]
	=
	pts_hst_pro->
	ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC] ;

}

/* joue pion blanc					*/
void jou_pio_0 	(void)
{
	if  /* haut 1 */
	(
		pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x
		&&
		pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y + 1
	)
	{
		if  /* deplacement normal */
		(
			pts_hst_pro->i_pos_ori_y != l7
		)
		{
			if   /* case d'arrive vide */
			(
			ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
			==
			VIDE
			)
			{
				pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
				dep_sim();
			}
			else /* case d'arrive occupe */
			{
				printf
				("\nLa case d'arrive doit tre libre");
				pro_pre();
				return;
			}
			jou_mvt_pio();
			return;
		}
		else 
/* transformation du pion en une autre piece */
		{
			if   /* case d'arrivee libre */
			(
				ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
				==
				VIDE
			)
			{
				 /* demande interactive de la piece  substituer */
				switch(cho_rem_pio())
				{
					/* transformation en cavalier */
					case 'C':

						pts_hst_pro->i_typ_mvt 	= MVT_PIO_CAV;
						dep_sim();
						pio_cav();
						jou_mvt_pio();
						return;
					/* transformation en reine */
					case 'D':
						pts_hst_pro->i_typ_mvt 	= MVT_PIO_REI;
						dep_sim();
						pio_rei();
						jou_mvt_pio();
						return;
				}
			}
			else
			{
				/* mvt impossible  */
				printf
				("\nLa case d'arrive doit tre libre");
				pro_pre();
				return;
			}

		}
	}
	else
	{
		if  /* haut 2 */
		(
			pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x
			&&
			pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y + 2
		)
		{
			if (pts_hst_pro->i_pos_ori_y == l2)
			{
				if
				(
					ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
					== VIDE
					&&
					ts_ech[pts_hst_pro->i_pos_x][(pts_hst_pro->i_pos_y)-1]
					.i_cam == VIDE

				)
				{
					/* deplacement simple */
					pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
					dep_sim();
				}
				else
				{
					/* mvt impossible  */
					printf
					("\nLes cases intermediares et d'arrivee");
					printf
					(" doivent etre libre");
					pro_pre();
					return;
				}
				jou_mvt_pio();

			}
			else
			{
				/* deplacement impossible  partir de cette pos */
				printf
				("\nSaut de 2 case possible seulement sur ligne 2");
				pro_pre();
				return;
			}

		}
		else
		{
			if  /* haut gauche */
			(
				pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x - 1
				&&
				pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y + 1
			)
			{
				switch(pts_hst_pro->i_pos_ori_y)
				{
				case l7:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case NOIR:
						/* demande interactive de la piece  substituer */
						switch(cho_rem_pio())
						{
						/* transformation en cavalier */
						case 'C':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
							pri_sim();
							pio_cav();
							jou_mvt_pio();
						/* transformation en reine */
						case 'D':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
							pri_sim();
							pio_rei();
							jou_mvt_pio();
						}
						return;
					case VIDE:
						printf("\nPas de piece a prendre");
						pro_pre();
						return;
					}

				case l5:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case NOIR:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;

					case VIDE:

						if
						(
						(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
						&&
						/* test position d'arrive du pion  prendre   */
						pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
						&&
						pts_hst_pro_p->i_pos_y == l5
						&&
						/*  test position de dpart du pion  prendre */
						pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
						&&
						pts_hst_pro_p->i_pos_ori_y == l7

						)
						{
							/* prise en passant */
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
							pri_pas();
							jou_mvt_pio();
							return;
						}
						else
						{
							printf("\nPas de piece a prendre");
							pro_pre();
							return;
						}

					}

				default:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case NOIR:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;

					case VIDE:

							printf("\nPas de piece a prendre");
							pro_pre();
							return;

					}
				}
			}
			else
			{
				if  /* haut droite */
				(
					pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x + 1
					&&
					pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y + 1
				)
				{
				switch(pts_hst_pro->i_pos_ori_y)
				{
				case l7:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case NOIR:
						/* demande interactive de la piece  substituer */
						switch(cho_rem_pio())
						{
						/* transformation en cavalier */
						case 'C':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
							pri_sim();
							pio_cav();
							jou_mvt_pio();
						/* transformation en reine */
						case 'D':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
							pri_sim();
							pio_rei();
							jou_mvt_pio();
						}
						return;
					case VIDE:
						printf("\nPas de piece a prendre");
						pro_pre();
						return;
					}
				case l5:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case NOIR:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;
					case VIDE:
						if
						(
							(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
							&&
							/* test position d'arrive du pion  prendre   */
							pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
							&&
							pts_hst_pro_p->i_pos_y == l5
							&&
							/*  test position de dpart du pion  prendre */
							pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
							&&
							pts_hst_pro_p->i_pos_ori_y == l7
						)
						{
							/* prise en passant */
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
							pri_pas();
							jou_mvt_pio();
							return;
						}
						else
						{
							printf("\nPas de piece a prendre");
							pro_pre();
							return;
						}
					}
				default:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
						case NOIR:
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
							pri_sim();
							jou_mvt_pio();
							return;

						case VIDE:
							printf("\nPas de piece a prendre");
							pro_pre();
							return;

					}
				}
				}
				else
				{
					/* mouvement impossible */
					printf("\nMouvement impossible");
					pro_pre();
					return;
				}
			}
		}
	}
}

/* joue pion noir 					*/
void jou_pio_1 	(void)
{
	
	if  /* bas 1 */
	(
		pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x
		&&
		pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y - 1
	)
	{

		if  /* deplacement normal */
		(
			pts_hst_pro->i_pos_ori_y != l2
		)
		{

			if   /* case d'arrive vide */
			(
			ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
			==
			VIDE
			)
			{
				pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
				dep_sim();

			}
			else /* case d'arrive occupe */
			{
				printf
				("\nLa case d'arrive doit tre libre");
				pro_pre();
				return;
			}

			jou_mvt_pio();

			return;
		}
		else 
/* transformation du pion en une autre piece */
		{
			if   /* case d'arrivee libre */
			(
				ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
				==
				VIDE
			)
			{
				 /* demande interactive de la piece  substituer */
				switch(cho_rem_pio())
				{
					/* transformation en cavalier */
					case 'C':

						pts_hst_pro->i_typ_mvt 	= MVT_PIO_CAV;
						dep_sim();
						pio_cav();
						jou_mvt_pio();
						return;
					/* transformation en reine */
					case 'D':
						pts_hst_pro->i_typ_mvt 	= MVT_PIO_REI;
						dep_sim();
						pio_rei();
						jou_mvt_pio();
						return;
				}
			}
			else
			{
				/* mvt impossible  */
				printf
				("\nLa case d'arrive doit tre libre");
				pro_pre();
				return;
			}

		}
	}
	else
	{
		if  /* bas 2 */
		(
			pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x
			&&
			pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y - 2
		)
		{
			if (pts_hst_pro->i_pos_ori_y == l7)
			{
				if
				(
					ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y].i_cam
					== VIDE
					&&
					ts_ech[pts_hst_pro->i_pos_x][(pts_hst_pro->i_pos_y)+1]
					.i_cam == VIDE

				)
				{
					/* deplacement simple */
					pts_hst_pro->i_typ_mvt 	= MVT_DEP_SIM;
					dep_sim();
				}
				else
				{
					/* mvt impossible  */
					printf
					("\nLes cases intermediare et d'arrive");
					printf
					(" doivent etre libre");
					pro_pre();
					return;
				}
				jou_mvt_pio();

			}
			else
			{
				/* deplacement impossible  partir de cette pos */
				printf
				("\nSaut de 2 case possible seulement sur ligne 2");
				pro_pre();
				return;
			}

		}
		else
		{
			if  /* bas gauche */
			(
				pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x - 1
				&&
				pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y - 1
			)
			{
				switch(pts_hst_pro->i_pos_ori_y)
				{
				case l2:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case BLANC:
						/* demande interactive de la piece  substituer */
						switch(cho_rem_pio())
						{
						/* transformation en cavalier */
						case 'C':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
							pri_sim();
							pio_cav();
							jou_mvt_pio();
						/* transformation en reine */
						case 'D':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
							pri_sim();
							pio_rei();
							jou_mvt_pio();
						}
						return;
					case VIDE:
						printf("\nPas de piece a prendre");
						pro_pre();
						return;
					}

				case l4:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case BLANC:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;

					case VIDE:

						if
						(
						(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
						&&
						/* test position d'arrive du pion  prendre   */
						pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
						&&
						pts_hst_pro_p->i_pos_y == l4
						&&
						/*  test position de dpart du pion  prendre */
						pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
						&&
						pts_hst_pro_p->i_pos_ori_y == l2

						)
						{
							/* prise en passant */
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
							pri_pas();
							jou_mvt_pio();
							return;
						}
						else
						{
							printf("\nPas de piece a prendre");
							pro_pre();
							return;
						}

					}

				default:

					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case BLANC:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;

					case VIDE:

							printf("\nPas de piece a prendre");
							pro_pre();
							return;

					}
				}
			}
			else
			{
				if  /* bas  droite */
				(
					pts_hst_pro->i_pos_x == pts_hst_pro->i_pos_ori_x + 1
					&&
					pts_hst_pro->i_pos_y == pts_hst_pro->i_pos_ori_y - 1
				)
				{
				switch(pts_hst_pro->i_pos_ori_y)
				{
				case l2:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case BLANC:
						/* demande interactive de la piece  substituer */
						switch(cho_rem_pio())
						{
						/* transformation en cavalier */
						case 'C':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_CAV;
							pri_sim();
							pio_cav();
							jou_mvt_pio();
						/* transformation en reine */
						case 'D':
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PIO_REI;
							pri_sim();
							pio_rei();
							jou_mvt_pio();
						}
						return;
					case VIDE:
						printf("\nPas de piece a prendre");
						pro_pre();
						return;
					}
				case l4:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
					case BLANC:
						pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
						pri_sim();
						jou_mvt_pio();
						return;
					case VIDE:
						if
						(
							(tpts_pie[NOIR]+pts_hst_pro_p->i_Id)->c_typ_pie == 'P'
							&&
							/* test position d'arrive du pion  prendre   */
							pts_hst_pro_p->i_pos_x == pts_hst_pro->i_pos_x
							&&
							pts_hst_pro_p->i_pos_y == l4
							&&
							/*  test position de dpart du pion  prendre */
							pts_hst_pro_p->i_pos_ori_x == pts_hst_pro->i_pos_x
							&&
							pts_hst_pro_p->i_pos_ori_y == l2
						)
						{
							/* prise en passant */
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_PAS;
							pri_pas();
							jou_mvt_pio();
							return;
						}
						else
						{
							printf("\nPas de piece a prendre");
							pro_pre();
							return;
						}
					}
				default:
					/* contenu de la case destination */
					switch(ts_ech[pts_hst_pro->i_pos_x][pts_hst_pro->i_pos_y]
					.i_cam)
					{
						case BLANC:
							pts_hst_pro->i_typ_mvt 	= MVT_PRI_SIM;
							pri_sim();
							jou_mvt_pio();
							return;

						case VIDE:
							printf("\nPas de piece a prendre");
							pro_pre();
							return;

					}
				}
				}
				else
				{
					/* mouvement impossible */
					printf("\nMouvement impossible");
					pro_pre();
					return;
				}
			}
		}
	}
		/*tst */
		/*printf(" jou pio 1 pos ori x/y: %i %i",pts_hst_pro->i_pos_ori_x,pts_hst_pro->i_pos_ori_y);*/

}



/* joue pion */
void jou_mvt_pio 	(void)
{

	/* echec pro precedente ?*/
	if (pts_hst_pro_p->i_ech==1)
	{
		/* verife  nouveau echec */
		/* 		par pice principale pro precedente ? */
		/* 	ou	par pice secondaire pro precedente ? */
		/* 	ou  par demasquage pro precedente ? */
		/* 	ou  par demasquage prof actuelle */

		if
		(
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_pri])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro_p->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
			)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			ann_cou();
			return;
		}
		else	/* roi n'est plus echec  */
		{
			/* roi n'est plus echec donc mat = N  */
			pts_hst_pro_p->i_mat = 0;

		}

	}
	else  	/* pas d'echec prof precedente */
	{

		/* Verifie echec propre camp par demasquage  */
		if
		(
			tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c]
			&&
			(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem_p_c])
									(pts_hst_pro->i_pos_x_R_p_c,
									 pts_hst_pro->i_pos_y_R_p_c,
									 pts_hst_pro->i_cam_adv)
		)

		{
			/* echec donc mvt impossible */
			pts_hst_pro->i_not = NOT_MIN;
			ann_cou();
			return;
		}
		else     /* pas d'echec */
		{

			/* roi ne se retrouve pas echec donc pat = N  */
			pts_hst_pro_p->i_pat = 0;

		}
	}
	/*tst */
	/*	printf("\nA jou mvt pio pos ori x/y: %i %i",pts_hst_pro->i_pos_ori_x,pts_hst_pro->i_pos_ori_y);*/

		/* verifie si cause echec camp adverse */
		/* par mvt pice principale ou par demasquage*/
		if
		(
			(*pts_pie->pf_ech_par)
						(pts_hst_pro->i_pos_x,
						 pts_hst_pro->i_pos_y,
						 &(pts_hst_pro->i_ech_dir_pri))
			||
			(
				tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem]
				&&
				(*tpf_cas_ctl_sta[pts_hst_pro->i_ech_dir_dem])
									(pts_hst_pro->i_pos_x_R_c_a,
									 pts_hst_pro->i_pos_y_R_c_a,
									 pts_hst_pro->i_cam)
			)
		)
		{
		   pts_hst_pro->i_ech=1;
		   pts_hst_pro->i_mat=1;
		   pts_hst_pro->i_pat=0;

		}
		else
		{
		   pts_hst_pro->i_ech=0;
		   pts_hst_pro->i_mat=0;
		   pts_hst_pro->i_pat=1;
		}


	/*tst */
	/*	printf("\nB jou mvt pio pos ori x/y: %i %i",pts_hst_pro->i_pos_ori_x,pts_hst_pro->i_pos_ori_y);*/



		/* recopie valeur grd et petit rock pour cam propre */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC]=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam][PET_ROC];

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC]=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam][GRA_ROC] ;

		/* recopie valeur grd et petit rock pour cam adverse */
		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC]=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][PET_ROC];

		(pts_hst_pro+1)->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC]=
		pts_hst_pro->
		ti_roc_cam_typ[pts_hst_pro->i_cam_adv][GRA_ROC] ;


}

/* annule coup				  */
void ann_cou (void)
{
		/* restore pice principale */
		if(tpf_res_pie_pri[pts_hst_pro->i_typ_mvt])
		{
			 (*tpf_res_pie_pri[pts_hst_pro->i_typ_mvt]) 	();
		}

		/* tst */
		/*printf("type mvt restore piece principale: %i",pts_hst_pro->i_typ_mvt);*/
		/* restore pice secondaire si fct existe */
		if(tpf_res_pie_sec[pts_hst_pro->i_typ_mvt])
		{
			 (*tpf_res_pie_sec[pts_hst_pro->i_typ_mvt]) 	();

		}
		/* profondeur precedente */
		pro_pre();
}

/* profondeur precedente	  */
void pro_pre (void)
{

		i_pro_act--;
		/* initialisation du  pionteurs sur hst */
		pts_hst_pro 	= &ts_hst_pro[i_pro_act];
		pts_hst_pro_p 	= &ts_hst_pro[i_pro_act-1];

		/* initialisation du  pionteurs piece actuelle  */
		pts_pie =
		tpts_pie[pts_hst_pro->i_cam]+pts_hst_pro->i_Id;
}

/*  Affichage de l'echiquier */
void aff_ech (int i_cam)
{
	int x,y;
	int b_n; /* blanc ou noir: 1 ou -1 */
	char c_lib_pie;
	char b;       /* Case noire		*/
	char n;		  /* Case noire		*/
	char g;       /* bas gauche 	*/
	char D;       /* haut droit 	*/
	char d;       /* bas droit 		*/
	char G;       /* haut gauche 	*/
	char h;       /* horizontal 	*/
	char v;       /* vertical  		*/

	if (0)
	{
	b='';       /* Case noire		*/
	n=' ';		  /* Case noire		*/
	g='';       /* bas gauche 	*/
	D='';       /* haut droit 	*/
	d='';       /* bas droit 		*/
	G='';       /* haut gauche 	*/
	h='';       /* horizontal 	*/
	v='';       /* vertical  		*/
	}
	else
	{
	b='#';       /* Case noire		*/
	n=' ';		  /* Case noire		*/
	g='+';       /* bas gauche 	*/
	D='+';       /* haut droit 	*/
	d='+';       /* bas droit 		*/
	G='+';       /* haut gauche 	*/
	h='=';       /* horizontal 	*/
	v='|';       /* vertical  		*/
	}
	/* pour les noir  (i_cam = 1) les noir sont en bas */
	if (i_cam == 1)
	{

		printf("\n  HHGGFFEEDDCCBBAA");
		printf("\n %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
		G,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,D);
		b_n = 1;
		for (y=2;y<=9;y++)
		{
			b_n *=-1;
			printf("\n%i%c",y-1,v);
			for (x=9;x>=2;x--)
			{
				b_n *=-1;
				if(ts_ech[x][y].i_cam<0)
				{

					if (b_n > 0) printf("%c%c",b,b);
					else 		  printf("%c%c",n,n);

				}
				else
				{
					c_lib_pie=
					(tpts_pie[(ts_ech[x][y].i_cam)]
					+
					(ts_ech[x][y].i_Id))->c_lib_pie;

					printf("%c%c",c_lib_pie,c_lib_pie);
				}

			}
			printf("%c%i",v,y-1);
		}
		printf("\n %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
		g,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,d);
		printf("\n  HHGGFFEEDDCCBBAA");

	}
	else
	   /* pour les blanc (i_cam = 0) les blanc sont en bas */
	{


		printf("\n  AABBCCDDEEFFGGHH");
		printf("\n %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
		G,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,D);
		b_n = 1;
		for (y=9;y>=2;y--)
		{
			b_n *=-1;
			printf("\n%i%c",y-1,v);
			for (x=2;x<=9;x++)
			{
				b_n *=-1;
				if(ts_ech[x][y].i_cam<0)
				{

					if (b_n > 0) printf("%c%c",b,b);
					else 		  printf("%c%c",n,n);

				}
				else
				{
					c_lib_pie=
					(tpts_pie[(ts_ech[x][y].i_cam)]
					+
					(ts_ech[x][y].i_Id))->c_lib_pie;

					printf("%c%c",c_lib_pie,c_lib_pie);

				}

			}
			printf("%c%i",v,y-1);
		}

		printf("\n %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
		g,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,h,d);
		printf("\n  AABBCCDDEEFFGGHH");
	}




}

/*  Affichage  piece   */
void aff_pie (int i_cam)
{
	int i_pie ;
	printf("\nTableau camp :  %d ",i_cam);
	printf("\nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir");
	for (i_pie = 0; i_pie < 18;i_pie++)
	{
		printf("\n%d\t",i_pie);
		printf("%d\t",(tpts_pie[i_cam]+i_pie)->i_pie_sui);
		printf("%d\t",(tpts_pie[i_cam]+i_pie)->i_pie_pre);
		printf("%d\t",(tpts_pie[i_cam]+i_pie)->i_pos_x);
		printf("%d\t",(tpts_pie[i_cam]+i_pie)->i_pos_y);
		printf("%i\t",(tpts_pie[i_cam]+i_pie)->i_for);
		printf("%c\t",(tpts_pie[i_cam]+i_pie)->c_lib_pie);
	}

}

/*  Affichage  historique  */

void aff_hst (int i_pro_deb, int i_pro_fin)
{
	int pro;
	printf("\nTableau historique prof de %d a %d",i_pro_deb,i_pro_fin);
	printf("\nPro\tId\to_x\to_y\tx\ty\tId2");
	printf("\n\tTyp_mvt\tDir_pri\tDir_dem\tDir_dpc");
	printf("\n\tNote\tNot max\tPat\tMat");
	for (pro = i_pro_deb; pro <= i_pro_fin; pro++)
	{
				/*0         1         2         3         4    
				/*12345678901234567890123456789012345678901234567890*/
		printf("\n--------------------------------------------------");
	
		printf("\n%d\t",pro);
		printf("%d\t",ts_hst_pro[pro].i_Id);
		
			printf("%d\t",ts_hst_pro[pro].i_pos_ori_x);
			printf("%d\t",ts_hst_pro[pro].i_pos_ori_y);
			printf("%d\t",ts_hst_pro[pro].i_pos_x);
			printf("%d\t",ts_hst_pro[pro].i_pos_y);
			printf("%d\t",ts_hst_pro[pro].i_Id_2p);
			
		printf("\n\t");
			printf("%d\t",ts_hst_pro[pro].i_typ_mvt);
			
			printf("%d\t",ts_hst_pro[pro].i_ech_dir_pri);
			printf("%d\t",ts_hst_pro[pro].i_ech_dir_dem);
			printf("%d",ts_hst_pro[pro].i_ech_dir_dem_p_c);
		
		printf("\n\t");
			printf("%d\t",ts_hst_pro[pro].i_not);
			printf("%d\t",ts_hst_pro[pro].i_not_max);

			printf("%d\t",ts_hst_pro[pro].i_pat);
			printf(  "%d",ts_hst_pro[pro].i_mat);

	}

}

/*  Affichage  notes   */
void aff_not (void)
{
	int cpt_lig;
	int cpt_mvt;
	int mei_mvt;
	int t_dep[2];
	int t_arr[2];
	mei_mvt = 0;
	/* calcul eilleur note */
	for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
	{
		if
		(
		ts_not_mvt_ini[cpt_mvt].i_not_mvt_ini
		>
		ts_not_mvt_ini[mei_mvt].i_not_mvt_ini
		)
		{
			mei_mvt = cpt_mvt;
		}

	}
		  /*0        1         2         3         4         5         6         7         */
		  /*1234567890123456789012345678901234567890123456789012345678901234567890123456789*/
	printf("LMDeAr Not P0M0P1M1!LMDeAr Not P0M0P1M1!LMDeAr Not P0M0P1M1!LMDeAr Not P0M0P1M1");
	for (cpt_lig = 0; cpt_lig <= 20; cpt_lig++)
	{
		if (cpt_lig< i_not_cpt_mvt_ini)
		{
		printf("\n%c",ts_not_mvt_ini[cpt_lig].c_lib_pie);
		printf("%d",ts_not_mvt_ini[cpt_lig].i_typ_mvt);
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig].i_not_mvt_ini);
		printf(" %2d",ts_not_mvt_ini[cpt_lig].ti_nbr_pat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig].ti_nbr_pat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig].ti_nbr_mat[1]);
		printf("!");
		}
		if (cpt_lig+21< i_not_cpt_mvt_ini)
		{
		printf("%c",ts_not_mvt_ini[cpt_lig+21].c_lib_pie);
		printf("%d",ts_not_mvt_ini[cpt_lig+21].i_typ_mvt);
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig+21].i_not_mvt_ini);
		printf(" %2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_pat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_pat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_mat[1]);
		printf("!");
		}
		if (cpt_lig+21*2< i_not_cpt_mvt_ini)
		{
		printf("%c",ts_not_mvt_ini[cpt_lig+21*2].c_lib_pie);
		printf("%d",ts_not_mvt_ini[cpt_lig+21*2].i_typ_mvt);
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*2].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*2].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*2].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*2].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig+21*2].i_not_mvt_ini);
		printf(" %2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_pat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_pat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_mat[1]);
		printf("!");
		}
		if (cpt_lig+21*3< i_not_cpt_mvt_ini)
		{
		printf("%c",ts_not_mvt_ini[cpt_lig+21*3].c_lib_pie);
		printf("%d",ts_not_mvt_ini[cpt_lig+21*3].i_typ_mvt);
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*3].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*3].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*3].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*3].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig+21*3].i_not_mvt_ini);
		printf(" %2d",ts_not_mvt_ini[cpt_lig+21*3].ti_nbr_pat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*3].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*3].ti_nbr_pat[1]);

		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*3].ti_nbr_mat[1]);
		printf("!");

		}

	}
	printf("\nNbr=%d Camp=%d Niv=%d Mei_mvt=%d Piece= %c Dep=%c%d Arr=%c%d",
		i_not_cpt_mvt_ini-1,
		ts_hst_pro[i_pro_act].i_cam_adv,
		i_pro_sim_max_sup,
		mei_mvt,
		ts_not_mvt_ini[mei_mvt].c_lib_pie,
		tc_lib_col[ts_not_mvt_ini[mei_mvt].i_pos_ori_x],
		ts_not_mvt_ini[mei_mvt].i_pos_ori_y-1,
		tc_lib_col[ts_not_mvt_ini[mei_mvt].i_pos_arr_x],
		ts_not_mvt_ini[mei_mvt].i_pos_arr_y-1
		);

}

/*  Affichage  notes nouvelle version  */
void aff_not_2 (void)
{
	int cpt_lig;
	int cpt_mvt;
	int mei_mvt;
	int t_dep[2];
	int t_arr[2];
	mei_mvt = 0;
	/* calcul eilleur note */
	for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
	{
		if
		(
		ts_not_mvt_ini[cpt_mvt].i_not_mvt_ini
		>
		ts_not_mvt_ini[mei_mvt].i_not_mvt_ini
		)
		{
			mei_mvt = cpt_mvt;
		}

	}
		  /*0        1         2         3         4         5         6         7         */
		  /*1234567890123456789012345678901234567890123456789012345678901234567890123456789*/
	    printf("N P DeAr Not   M P   m p!N P DeAr Not   M P   m p!N P DeAr Not    M P    m p");
	for (cpt_lig = 0; cpt_lig <= 20; cpt_lig++)
	{
		if (cpt_lig< i_not_cpt_mvt_ini)
		{
		printf("\n%2d",cpt_lig);
		printf(" %c",ts_not_mvt_ini[cpt_lig].c_lib_pie);
		printf(" %c",tc_lib_col[ts_not_mvt_ini[cpt_lig].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig].i_not_mvt_ini);
		printf( "%4d",ts_not_mvt_ini[cpt_lig].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig].ti_nbr_pat[0]);
		printf( "%4d",ts_not_mvt_ini[cpt_lig].ti_nbr_mat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig].ti_nbr_pat[1]);
		printf("!");
		}
		if (cpt_lig+21< i_not_cpt_mvt_ini)
		{
		printf("%2d",cpt_lig+21);
		printf(" %c",ts_not_mvt_ini[cpt_lig+21].c_lib_pie);
		printf(" %c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig+21].i_not_mvt_ini);
		printf( "%4d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_pat[0]);
		printf( "%4d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_mat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21].ti_nbr_pat[1]);
		printf("!");
		}
		if (cpt_lig+21*2< i_not_cpt_mvt_ini)
		{
		printf("%2d",cpt_lig+21*2);
		printf(" %c",ts_not_mvt_ini[cpt_lig+21*2].c_lib_pie);
		printf(" %c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*2].i_pos_ori_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*2].i_pos_ori_y-1));
		printf("%c",tc_lib_col[ts_not_mvt_ini[cpt_lig+21*2].i_pos_arr_x]);
		printf("%d",(ts_not_mvt_ini[cpt_lig+21*2].i_pos_arr_y-1));
		printf(" %3d",ts_not_mvt_ini[cpt_lig+21*2].i_not_mvt_ini);
		printf( "%4d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_mat[0]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_pat[0]);
		printf( "%4d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_mat[1]);
		printf( "%2d",ts_not_mvt_ini[cpt_lig+21*2].ti_nbr_pat[1]);
		printf("!");
		}


	}
	printf("\nNbr=%d Camp=%d Niv=%d Mei_mvt=%d Piece= %c Dep=%c%d Arr=%c%d",
		i_not_cpt_mvt_ini-1,
		ts_hst_pro[i_pro_act].i_cam_adv,
		i_pro_sim_max_sup,
		mei_mvt,
		ts_not_mvt_ini[mei_mvt].c_lib_pie,
		tc_lib_col[ts_not_mvt_ini[mei_mvt].i_pos_ori_x],
		ts_not_mvt_ini[mei_mvt].i_pos_ori_y-1,
		tc_lib_col[ts_not_mvt_ini[mei_mvt].i_pos_arr_x],
		ts_not_mvt_ini[mei_mvt].i_pos_arr_y-1
		);

}

/*  Gestion interruption clavier */
int get_key(void)
{
/*	 int key, lo , hi;

	 key 	= bioskey(0);
	 lo 	= key & 0X00FF;
	 hi 	= (key &0XFF00)>>8;

	 return ((lo==0) ? hi+256:lo);
*/
}

void sto_sim (void)
{
//	if(bioskey(1))
	if(0)
	{
		if(get_key ()== ESC)
		 {
			 fflush(stdin);
			 printf("\nVoulez vous interrompre le calcul? (O/N)");

			 if(tolower(getchar())== 'o')
			 {
				i_pro_sim_max_sup = i_pro_act;
				i_pro_sim_max_inf = i_pro_act;
			 }
		 }

	}

}
/* Choix remplacement du pion */

int  cho_rem_pio (void)
{

	 int c;
	 while (1)
	 {
		 fflush(stdin);

		 printf
		 ("\nQuelle piece voulez vous pour remplacer le pion?");
		 printf
		 ("\nReine: D Cavalier: C ");

		 c = toupper(getchar());

		 if
		 (
			c == 'D'
			||
			c == 'C'

		 )
		 {
			return c;
		 }
	 }
}

/* Pion en cavalier */

void  pio_cav (void)
{
	pts_pie->i_for			= 2;
	pts_pie->pf_ini_hst_mvt = ini_hst_mvt_cav;
	pts_pie->pf_jou         = jou_ctfr;
	pts_pie->pf_ech_par     = ech_par_cav;
	pts_pie->i_mvt_uni_dir  = 1;
	pts_pie->c_typ_pie      = 'C';
	if (pts_hst_pro->i_cam == BLANC)
	{pts_pie->c_lib_pie      = 'C';
}
	else
	{pts_pie->c_lib_pie      = 'c';
}

}

/* Pion en reine */

void  pio_rei (void)
{
	pts_pie->i_for			= 4;
	pts_pie->pf_ini_hst_mvt = ini_hst_mvt_rei;
	pts_pie->pf_jou         = jou_ctfr;
	pts_pie->pf_ech_par     = ech_par_rei;
	pts_pie->i_mvt_uni_dir  = 0;
	pts_pie->c_typ_pie      = 'D';
	if (pts_hst_pro->i_cam == BLANC)
	{pts_pie->c_lib_pie      = 'D';
}
	else
	{pts_pie->c_lib_pie      = 'd';
}

}

